• hdu 4289 Control(最小割 + 拆点)


    http://acm.hdu.edu.cn/showproblem.php?pid=4289

    Control

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 2247    Accepted Submission(s): 940


    Problem Description
      You, the head of Department of Security, recently received a top-secret information that a group of terrorists is planning to transport some WMD 1 from one city (the source) to another one (the destination). You know their date, source and destination, and they are using the highway network.
      The highway network consists of bidirectional highways, connecting two distinct city. A vehicle can only enter/exit the highway network at cities only.
      You may locate some SA (special agents) in some selected cities, so that when the terrorists enter a city under observation (that is, SA is in this city), they would be caught immediately.
      It is possible to locate SA in all cities, but since controlling a city with SA may cost your department a certain amount of money, which might vary from city to city, and your budget might not be able to bear the full cost of controlling all cities, you must identify a set of cities, that:
      * all traffic of the terrorists must pass at least one city of the set.
      * sum of cost of controlling all cities in the set is minimal.
      You may assume that it is always possible to get from source of the terrorists to their destination.
    ------------------------------------------------------------
    1 Weapon of Mass Destruction
     
    Input
      There are several test cases.
      The first line of a single test case contains two integer N and M ( 2 <= N <= 200; 1 <= M <= 20000), the number of cities and the number of highways. Cities are numbered from 1 to N.
      The second line contains two integer S,D ( 1 <= S,D <= N), the number of the source and the number of the destination.
      The following N lines contains costs. Of these lines the ith one contains exactly one integer, the cost of locating SA in the ith city to put it under observation. You may assume that the cost is positive and not exceeding 107.
      The followingM lines tells you about highway network. Each of these lines contains two integers A and B, indicating a bidirectional highway between A and B.
      Please process until EOF (End Of File).
     
    Output
      For each test case you should output exactly one line, containing one integer, the sum of cost of your selected set.
      See samples for detailed information.
     
    Sample Input
    5 6
    5 3
    5
    2
    3
    4
    12
    1 5
    5 4
    2 3
    2 4
    4 3
    2 1
     
    Sample Output
    3
     
    详细请参考:

    题目大意:

    N个点,每个点都有各自的cost, 然后M 无向条边

    要求割去S点到D路线中的点,使之无法从S到D ,而且要求消耗的cost和最小.  

    这是一道网络流的题. 算的是最小割. 根据最大流最小割定理. 可以直接算最大流;

    但是这题的的流量限制是在点上的.所以要我们来拆点.

    我这题是把i 点的  点首和点尾 分别设为 i 和 i+n;  显然 最后会得到2*n个点

    如图:

    将点1拆分成两部分分别为点首1和点尾1+n,然后把点首到点尾的流量限制设成 题目要求的cost; ,点1---->(1+n)的花费即为封锁城市1的代价

    而点与点之间(两座城市之间)的边,要设成正无穷大, 因为边不消耗cost;

    然后从S的点首S 跑到 D的点尾 D+n  就可以计算出最小割了.

    #include<stdio.h>
    #include<algorithm>
    #include<queue>
    #include<string.h>
    #define N 510
    #define INF 0x3f3f3f3f
    using namespace std;
    
    struct Edge
    {
        int u, v, flow, next;
    } edge[N * N];
    
    int layer[N], head[N], cnt;
    
    void Init()
    {
        memset(head, -1, sizeof(head));
        cnt = 0;
    }
    
    void AddEdge(int u, int v, int flow)
    {
        edge[cnt].u = u;
        edge[cnt].v = v;
        edge[cnt].flow = flow;
        edge[cnt].next = head[u];
        head[u] = cnt++;
    
        swap(u, v);
    
        edge[cnt].u = u;
        edge[cnt].v = v;
        edge[cnt].flow = 0;
        edge[cnt].next = head[u];
        head[u] = cnt++;
    
    }
    
    bool BFS(int Start, int End)
    {
        queue<int>Q;
        memset(layer, -1, sizeof(layer));
        Q.push(Start);
        layer[Start] = 1;
        while(!Q.empty())
        {
            int u = Q.front();
            Q.pop();
            if(u == End)
                return true;
            for(int i = head[u] ; i != -1 ; i = edge[i].next)
            {
                int v = edge[i].v;
                if(layer[v] == -1 && edge[i].flow > 0)
                {
                    layer[v] = layer[u] + 1;
                    Q.push(v);
                }
            }
        }
        return false;
    }
    
    int DFS(int u, int Maxflow, int End)
    {
        if(u == End)
            return Maxflow;
        int uflow = 0;
        for(int i = head[u] ; i != -1 ; i = edge[i].next)
        {
            int v = edge[i].v;
            if(layer[v] == layer[u] + 1 && edge[i].flow > 0)
            {
                int flow = min(edge[i].flow, Maxflow - uflow);
                flow = DFS(v, flow, End);
                edge[i].flow -= flow;
                edge[i^1].flow += flow;
    
                uflow += flow;
                if(uflow == Maxflow)
                    break;
            }
        }
        if(uflow == 0)
            layer[u] = 0;
        return uflow;
    }
    
    int Dinic(int Start, int End)
    {
        int Maxflow = 0;
        while(BFS(Start, End))
            Maxflow += DFS(Start, INF, End);
        return Maxflow;
    }
    
    int main()
    {
        int m, n, s, t;
        while(~scanf("%d%d", &m, &n))
        {
            Init();
            scanf("%d%d", &s, &t);
            int u, v, flow;
            for(int i = 1 ; i <= m ; i++)
            {
                scanf("%d", &flow);
                AddEdge(i, i + m, flow);
            }
            while(n--)
            {
                scanf("%d%d", &u, &v);
                AddEdge(u + m, v, INF);
                AddEdge(v + m, u, INF);
            }
            printf("%d
    ", Dinic(s, t + m));
        }
        return 0;
    }
    View Code
  • 相关阅读:
    CQOI2016 不同的最小割 (最小割树模板)(等价流树的Gusfield构造算法)
    CSP2019 D2T2 划分 (单调队列DP)
    Android弱网测试中关于网络检测的一些借鉴方法
    IOS的Crash情况在Crashlytics平台上统计解决方案的一点遗憾(截止到2015年6月14日)
    关于selenium2(webdriver)自动化测试过程中标签页面或者窗口切换的处理解决方案
    针对电信乌龙事件的深度测试: 广州电信错误将深圳地区189的号码在3G升级4G申请时从广州网厅发货,造成深圳用户收到4G卡后无法激活,深圳电信找不到订单
    spring mvc + freemarker优雅的实现邮件定时发送
    使用phantomjs实现highcharts等报表通过邮件发送(本文仅提供完整解决方案和实现思路,完全照搬不去整理代码无法马上得到效果)
    模拟http或https请求,实现ssl下的bugzilla登录、新增BUG,保持会话以及处理token
    xmlrpc实现bugzilla api调用(无会话保持功能,单一接口请求)
  • 原文地址:https://www.cnblogs.com/qq2424260747/p/4729312.html
Copyright © 2020-2023  润新知